﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private sql As SQL
	Private btnAdd As B4XView
	Private B4XTable1 As B4XTable
	Private const DBFile As String = "5a.db"
	Private PrefDialog As PreferencesDialog
	Private EditCol As B4XTableColumn
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("1")
	If File.Exists(File.DirInternal, DBFile) = False Then
		File.Copy(File.DirAssets, DBFile, File.DirInternal, DBFile)
'	Else 
'		File.Delete	(File.DirInternal, DBFile)
	End If
	sql.Initialize(File.DirInternal, "5a.db", False)
'===========================================================================
	PrefDialog.Initialize(Root, "Redacción de Tareas", 300dip, 300dip)
	PrefDialog.LoadFromJson (File.ReadString(File.DirAssets, "template1.json"))	
'===========================================================================
	EditCol =B4XTable1.AddColumn("Fecha", B4XTable1.COLUMN_TYPE_TEXT)
	EditCol.Width = 25%x
	EditCol =B4XTable1.AddColumn("Tarea", B4XTable1.COLUMN_TYPE_TEXT)
	EditCol.Width = 75%x
	B4XTable1.RowHeight = 70dip
	B4XTable1.MaximumRowsPerPage=7
	B4XTable1.BuildLayoutsCache(B4XTable1.MaximumRowsPerPage)
'===========================================================================
	Cargar_Datos
	
End Sub
Sub Cargar_Datos
	Dim Data As List
	Data.Initialize
	Dim rs As ResultSet = sql.ExecQuery("SELECT Fecha, detalle FROM tareas")
	Do While rs.NextRow
		Dim row(2) As Object
		row(0) = rs.GetString("fecha")
		row(1) = rs.GetString("detalle")
		Data.Add(row)
	Loop
	rs.Close
	B4XTable1.SetData(Data)
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.


Private Sub btnAdd_Click
	ShowDialog(CreateMap(),0)
End Sub
Private Sub ShowDialog(Item As Map, RowId As Long)
	Wait For (PrefDialog.ShowDialog(Item, "OK", "CANCEL")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		Dim parametros As List
		parametros.Initialize
'		DateTime.DateFormat ="yyyy-MM-dd"
		parametros.AddAll(Array( DateTime.Date(Item.Get("Fecha")), Item.Get("Tarea"))) 'keys based on the template json file
		If RowId = 0 Then 'new row
			B4XTable1.sql1.ExecNonQuery2($"INSERT INTO data VALUES(?, ?)"$, parametros)
			B4XTable1.ClearDataView
			sql.ExecNonQuery2 ("INSERT INTO tareas (fecha, detalle) VALUES (?,?)", parametros)
		Else
			parametros.Add(RowId)
			'first column is c0. We skip it as this is the "edit" column
			B4XTable1.sql1.ExecNonQuery2("UPDATE data SET c0 = ?, c1 = ? WHERE rowid = ?", parametros)
			B4XTable1.Refresh
			'Update de SQL no probado, borrar el comentario despues
			'sql.ExecNonQuery2("UPDATE tareas SET fecha = ? , detalle = ? WHERE rowid =  ?" , Array As Object(Item.GetValueAt(1), Item.GetValueAt(2), RowId))
						
		End If
	End If
End Sub

Private Sub B4XTable1_CellLongClicked (ColumnId As String, RowId As Long)
    Log(B4XTable1.GetRow(RowId))
	
	Dim Item As Map = B4XTable1.GetRow(RowId)
'	Item.Put("Fecha",DateTime.DateParse(Item.GetValueAt(0)))
	Log(Item.GetValueAt(0))
	ShowDialog(Item, RowId)
End Sub